






import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:vero_express/DLL/API_Body.dart';
import 'package:vero_express/DLL/ActionResults_ws.dart';

import '../vero_express.dart';

class BC_Connector{



      BC_Connector._privateConstructor();
      static final BC_Connector _instance = BC_Connector._privateConstructor();
      static BC_Connector get instance { return _instance;}


Future<ActionResults_ws> postman(String  webService, String jsonFilter) async{}
//Future<ActionResults_ws> postman(String  webService, String jsonFilter) async{}

Future<ActionResults_ws> subscribe(API_Body jsBody) async{
     http.Response response = await http.post(
       WebConfig.baseWS + jsBody.webServiceName,
        headers: WebConfig.headers_,
         body:  '{"typeAction": "'+jsBody.typeAction+'","navCompany": "'+WebConfig.navCompany+'","odataFilter": "'+jsBody.odataFilter+'"}'
         );
  if (response.statusCode == 200) {                
   return  ActionResults_ws.fromJson(json.decode(response.body));
  } else {    
    throw Exception('Failed to load post');
  }  
}

Future<ActionResults_ws> authorizationPostMan(API_Body jsBody, String token) async  {
DateTime local_datetime = DateTime.now();
token =  token==null ? await  DZ_LocalStorage.instance.getItem('Token') : token;         
     http.Response response = await http.post(
       WebConfig.baseWS + jsBody.webServiceName,
 headers:
        {
        "Content-type" : "application/json",
        "Authorization" : "Bearer $token"
        
      },
         body:  '{"tZ": "'+local_datetime.timeZoneOffset.inHours.toString()+'",  "typeAction": "'+jsBody.typeAction+'","navCompany": "'+WebConfig.navCompany+'","odataFilter": "'+jsBody.odataFilter+'"}'
         );
 
  if (response.statusCode == 200) {
   return  ActionResults_ws.fromJson(json.decode(response.body));
  } else {    
    throw Exception('Failed to load post'+response.statusCode.toString());
  }
}

Future<ActionResults_ws> readMultiple(API_Body jsBody, String token) async {

  DateTime local_datetime = DateTime.now();
token =  token==null ? await  DZ_LocalStorage.instance.getItem('Token') : token;  

print("AMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMigo");
print( WebConfig.baseWS + jsBody.webServiceName);
     http.Response response = await http.post(
       WebConfig.baseWS + jsBody.webServiceName,
 headers:
        {
        "Content-type" : "application/json",
        "Authorization" : "Bearer $token"
        
      },
         body:  '{"tZ": "'+local_datetime.timeZoneOffset.inHours.toString()+'",  "typeAction": "'+jsBody.typeAction+'","navCompany": "'+WebConfig.navCompany+'","odataFilter": "'+jsBody.odataFilter+'"}'
         );
 

 print(response.body);
 print(response.headers);
  if (response.statusCode == 200) {
   return  ActionResults_ws.fromJson(json.decode(response.body));
  } else {    
    throw Exception('Failed to load post'+response.statusCode.toString());
  }

} 



Future<ActionResults_ws> delete(API_Body jsBody, String token) async {

    DateTime local_datetime = DateTime.now();
token =  token==null ? await  DZ_LocalStorage.instance.getItem('Token') : token;         
     http.Response response = await http.post(
       WebConfig.baseWS + jsBody.webServiceName,
 headers:
        {
        "Content-type" : "application/json",
        "Authorization" : "Bearer $token"
        
      },
         body:  '{"tZ": "'+local_datetime.timeZoneOffset.inHours.toString()+'",  "typeAction": "'+jsBody.typeAction+'","navCompany": "'+WebConfig.navCompany+'","odataFilter": "'+jsBody.odataFilter+'"}'
         );
 
  if (response.statusCode == 200) {
   return  ActionResults_ws.fromJson(json.decode(response.body));
  } else {    
    throw Exception('Failed to load post'+response.statusCode.toString());
  }

}


Future<ActionResults_ws> updateField(API_Body jsBody, String token) async {

    DateTime local_datetime = DateTime.now();
token =  token==null ? await  DZ_LocalStorage.instance.getItem('Token') : token;         
     http.Response response = await http.post(
       WebConfig.baseWS + jsBody.webServiceName,
 headers:
        {
        "Content-type" : "application/json",
        "Authorization" : "Bearer $token"
        
      },
         body:  '{"tZ": "'+local_datetime.timeZoneOffset.inHours.toString()+'",  "typeAction": "'+jsBody.typeAction+'","navCompany": "'+WebConfig.navCompany+'","odataFilter": "'+jsBody.odataFilter+'"}'
         );
 
  if (response.statusCode == 200) {
   return  ActionResults_ws.fromJson(json.decode(response.body));
  } else {    
    throw Exception('Failed to load post'+response.statusCode.toString());
  }
  
}












}




